;finds the length of null (0x00) terminated string using sub-routine

org 0xC000

strt: 
 lxi h, 0xF000
 call strlen
 hlt


;sub-routine length
; arguments: HL = pointer to string
; returns: C = count of characters
; uses A
strlen:
 push h         ;save HL
 mvi c, 00h

strlen_next:
 mov a, m
 ora a
 jz strlen_done
 inx h
 inr c
 jmp strlen_next

strlen_done:
 pop h
 ret

;;;;;;;;;;;;;;;;;;;;;;;;;
;c = count
;hl = source
;de = dest
memcpy:
memcpy_next:
 xra a
 cmp c
 jz memcpy_done

 mov a, m
 stax d
 inx h
 inx d
 dcr c
 jnz memcpy_next

memcpy_done:
 ret
