;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; ascending.asm
;
; this program sorts data in ascending order
;
; 

org 0xC000

src equ 0xF000		; source address
dst equ 0xF100		; destination address

 xra a			; set A to 00
 lxi d, dst		; load destination address in DE register

next_a:			
 lxi h, src
 mov c, m

sort:
 inx h
 cmp m
 jnz next
 stax d
 inx d
next:
 dcr c
 jnz sort

 inr a
 jnz next_a

 hlt

END