;reverse a string terminated by null character (0x00)

;address where string is stored
str equ 0f000h

;set origin
org 0c000h

 lxi h, str       ;load address of string
 lxi d, str       ;point to the first char

loop:
 mov a, m         ;load next character
 cpi 00h          ;check for null character
 jz reverse

 inx h
 jmp loop

reverse:
 dcx h

next_char:
 mov a, l
 cmp e
 jc done

 mov b, m         ;load character from right side
 ldax d		  ;load character from left side
 mov m, a
 mov a, b
 stax d

 inx d
 dcx h
 jmp next_char
 
done:
 hlt